; -----------------------------------------------------
; Peace and Protection (by misspai)
; -----------------------------------------------------
; Function key definitions (in
; remotes to allow #groups)
; -----------------------------------------------------
alias _retakecheck {
  .timer903 0 14 _retakecheck
  if ((%_self.lag.count > 30) || ($right(%-uhsearch,6) == .clean) || (%pp.net == offline)) halt
  set %-uhsearch %-uhsearch .nick
  .raw userhost %_nickretake
}
on 1:nick:if (($nick == %_nickretake) && (%_+nickrc) && (%pp.net != Offline)) _retakecheck
on 1:quit:if (($nick == %_nickretake) && (%_+nickrc)) _retakecheck
on 1:part:#:if (($nick == %_nickretake) && (%_+nickrc)) _retakecheck
on 1:notice:*Your ghost has been killed*:?:if (%_nickretake != $null) _retakecheck
on 1:notice:*Nick*has been released from custody*:?:if (%_nickretake != $null) _retakecheck
#^fkeynorm on
alias f1 _selfstop F1 4 | sp
alias sf1 _selfstop ShiftF1 2 | %-sf1 | if ($left(%-sf1,4) == .dcc) unset %-sf1
alias cf1 _selfstop CtrlF1 2 | %-cf1 | if ($left(%-cf1,4) == .dcc) unset %-cf1
alias f2 _selfstop F2 2 | if ($left($active,1) == =) dcp | else ping
alias sf2 _selfstop ShiftF2 2 | if ($chan($active) == $active) chaninfo $active | elseif (($chr(32) isin $active) || (@ isin $active)) _error Use ShiftF2 to get info from a channel, query, or DCC chat only. | else whois " $+ $remove($active,=) $+ "
alias cf2 avglag
alias f3 cd
alias sf3 if (?: !iswm %cdp.drive) cd d | elseif (%cdp.inifile == $null) cd i | elseif ($_isopen(@CD)) cd p | else cd v
alias cf3 %-cf3
alias sf4 {
  if (%-last.uctcp == *clones*) ping %-last.clones
  elseif (%-last.uctcp == *clrstat*) clrstat %-last.clones
  elseif (%-last.uctcp == *msg*) .ignore -r %_last.unsolicited
  elseif (%-last.uctcp == *dcc*) .dcc send %-last.dccinc
  elseif (%-last.uctcp != $null) {
    set %_arhelp ctcpreply %-last.uctcp 
    _askr _arhelp $gettok(%-last.uctcp,2-,32) reply to send to $gettok(%-last.uctcp,1,32) $+ ?
  }
  unset %-last.uctcp
}
alias f5 if (($chr(32) !isin $active) && (@ !isin $active)) _selfstop F5 3 | mp *
alias sf5 playlist
alias cf5 if (($chr(32) !isin $active) && (@ !isin $active)) _selfstop CtrlF5 3 | mid *
alias f6 if ($active == @Colors) { window -c @Colors | halt } | if ((%+f6.simple.color) && ($window(@Click) == $null)) colorwin | else cnc
alias sf6 if ($active == @Colors) { window -c @Colors | halt } | if (($_not(%+f6.simple.color)) && ($window(@Click) == $null)) colorwin | else cnc +
alias cf6 if ($active == @Colors) { window -c @Colors | halt } | cncoff
alias f7 if (%_last.notice.nick != $null) editbox -a /n %_last.notice.nick $chr(160)
alias f8 set %_arhelp fk %-keybop.chan %-keybop.nick | if (%-keybop.nick != $null) _askr _arhelp Reason to kick %-keybop.nick $+ ? (and any clones)
alias sf8 {
  if (%-keybop.nick != $null) {
    if ($address(%-keybop.nick,5) == $null) ban %-keybop.chan $_ppmask(%-keybop.addr,3)
    else {
      set %_arhelp cb %-keybop.chan %-keybop.nick
      _askr _arhelp Reason to kickban %-keybop.nick $+ ? (and any clones)
    }
  }
}
alias cf8 {
  if (%_+nickrecv) {
    dispa Requesting NickServ to release nick...
    set %.pw %autonk. [ $+ [ %_nickretake ] ]
    ns release %_nickretake $_pwenc(%.pw)
    unset %_+nickrecv
    return
  }
  if ((%_+nickdal) && (%_+nickkill != $true)) {
    dispa Performing NickServ KILL on %col.target $+ %_nickretake $+ ...
    set %_+nickkill $true
    _retakecheck
    return
  }
  if (%_+nickrc) {
    dispa Nick retake cancelled.
    unset %_+nickrc %_+nickdal %_+nickkill %_+nickrecv
    .timer903 off
    halt
  }
  if (%_nickretake == $null) halt
  unset %_+nickkill %_+nickdal %_+nickrecv
  if ((%s^c == ChanServ) && ($findtok(%autonk.nicks,%_nickretake,32) != $null)) {
    set %_+nickdal $true
    dispa You will take the nick %col.target $+ %_nickretake $+  when possible. Press %col.option $+ CtrlF8 again to %col.dark $+ NickServ KILL. (auto for ghosts)
    _retakecheck
  }
  else dispa You will take the nick %col.target $+ %_nickretake $+  as soon as it is available. Press %col.option $+ CtrlF8 again to cancel.
  set %_+nickrc $true
  _retakecheck
}
alias f9 .disable #^fkeynorm | .enable #_fkeysound | _fkeytitle | dispa Sound FKeys enabled. See titlebar for sound type and keys. %col.option $+ (F9 to disable, F12 changes file type)
alias sf9 if (%_sf9.server == $null) { server | return } | if (%_sf9.server == *) set %_arhelp server $gettok(%_ns.found,$r(1,$_numtok(32,%_ns.found)),32)  | else set %_arhelp server %_sf9.server | _pentry _arhelp6667 Connecting to $gettok(%_arhelp,2,32) $+ -Port to use?
alias cf9 911
alias 911 {
  if ($_isopen(@Alert)) window -c @Alert
  if (%_ignoreall) {
    disps %col.att $+ Disabling ignore-all...
    .ignore -r *
    if (%pp.net != offline) .timer904 1 2 _qsp Q
    unset %_ignoreall
    if ((%+cf9.nickchange) && (%_cf9.oldnick != $me) && (%_cf9.oldnick != $null)) { nick %_cf9.oldnick | unset %_cf9.oldnick %_oldnick }
  }
  else {
    disps %col.att $+ Ignoring all messages, notices, CTCPs, and invites %col.option $+ (CtrlF9 to undo)
    .ignore -tnikp *
    set %_ignoreall $true
    .timer904 off | .timer905 off | .timer906 off | .timer908 off | .timer910 off
    set %self.lag ??
    if (%+cf9.nickchange) { set %_cf9.oldnick $me | rn }
  }
}
alias f10 {
  if (%_f10dns != $null) { clipboard %_f10dns | unset %_f10dns }
  elseif ((%pp.net == offline) && ($chr(32) !isin %_rejoin.keys)) {
    if (%_rejoin.chans != $null) {
      unset %_rejoin.chans %_rejoin.keys
      disps Rejoin-on-reconnect canceled. (You will not rejoin any channels this reconnect)
    }
  }
  elseif ($left(%-f10join.chan,1) == *) {
    repjoin $gettok(%-f10join.chan,2,32)
    unset %-f10join.chan %-prevf10join.key
  }
  elseif (%-f10join.chan != $null) {
    j %-f10join.chan
    set %-prevf10join.key $gettok(%-f10join.chan,2,32)
    unset %-f10join.chan
  }
}
alias f11 _selfstop F11 1 | fav j
alias f12 if (%_away.why == $null) a | else back
alias sf12 if (%_away.why == $null) qa | else qb
alias cf12 if ($active == @Away) window -c @Away | else awaylog
#^fkeynorm end
#_fkeysound off
alias f1 if (%fkeys.type == mp) randmp | elseif (%fkeys.type == midi) randmid | elseif (%fkeys.type == wave) randwav | else zrand %fkeys.typex
alias f2 if (%fkeys.type == mp) mp | elseif (%fkeys.type == midi) mid | elseif (%fkeys.type == wave) wav | else z %fkeys.typex
alias f3 if ($1 == $null) _askr f3 Words or filename mask to find? | if (%fkeys.type == mp) mp $1- | elseif (%fkeys.type == midi) mid $1- | elseif (%fkeys.type == wave) wav $1- | else z %fkeys.typex $1-
alias f5 if (%fkeys.type == mp) mp ? | elseif (%fkeys.type == midi) mid ? | elseif (%fkeys.type == wave) wav ? | else z %fkeys.typex ?
alias f6 drand
alias f8 rrand
alias f12 {
  if (%fkeys.type == mp) set %fkeys.type Midi
  elseif (%fkeys.type == midi) set %fkeys.type Wave
  elseif (%fkeys.type == wave) {
    if (%soundfile.custom == $null) set %fkeys.type MP
    else { set %fkeys.typex $gettok(%soundfile.custom,1,32) | set %fkeys.type %soundfile. [ $+ [ %fkeys.typex ] ] | _fkeytitle | return }
  }
  elseif (%fkeys.typex != $null) {
    set %.tok $findtok(%soundfile.custom,%fkeys.typex,32)
    if (%.tok == $null) set %fkeys.type MP
    else {
      inc %.tok
      set %fkeys.typex $gettok(%soundfile.custom,%.tok,32)
      if (%fkeys.typex == $null) set %fkeys.type MP
      else { set %fkeys.type %soundfile. [ $+ [ %fkeys.typex ] ] | _fkeytitle | return }
    }
  }
  else set %fkeys.type MP
  unset %fkeys.typex
  _fkeytitle
}
alias f9 .disable #_fkeysound | .enable #^fkeynorm | dispa Sound FKeys disabled.
alias f7 splay stop
alias f10 splay stop
alias f11 if (%fkeys.type == mp) mpindex | elseif (%fkeys.type == midi) midindex | elseif (%fkeys.type == wave) wavindex | else zindex %fkeys.typex
#_fkeysound end
alias _fkeytitle titlebar --> %fkeys.type <-- F1) Rand F2) Pick F3) Find -- F5) List F6) Delete F8) Repeat -- F12) Next type
