; -----------------------------------------------------
; Peace and Protection (by misspai)
; -----------------------------------------------------
; Main (normal) aliases
; (Third section)
; -----------------------------------------------------
; Express File Finder
; -----------------------------------------------------
; /ff [-e/f/a/n] [d:][\dir][file/matchtext][.ext]
; if drive is given, only that drive is searched
; if dir is given, only that dir tree is searched
; file or matchtext is used to match filename (none = *.*)
; if a 1/2/3/4 letter extension is given, that exact extension must be matched
; -e means to match exact filename -f means that exact file if exists
; otherwise name is surrounded by *, spaces become *, and _ and - become ?
; -a means to add to current filelist if any, else filelist is reset; -n = remain minimized
; s = recent sends, g = recent gets, d = default d/l dir, m = mp2/3s, w = waves, i = midis, l = logs, c = mircdir, p = p&pdir, r = recent files, x = incompletes, z = custom sound
find {
  if (3.1 isin $os) _error Sorry, Express File Finder does not work properly on Windows 3.11
  unset %_findrcpop %.ff.ok2
  if ($1 == $null) _quickhelp /find
  if (($left($1,1) == -) || (($len($1) == 1) && (($2 == $null) || (($1 == z) && ($3 == $null))))) { set %.ff.opt - $+ $1 | set %.ff.to $2- }
  else { set %.ff.opt - | set %.ff.to $1- }
  if (z isin %.ff.opt) { set %.ff.stype $gettok(%.ff.to,1,32) | set %.ff.to $gettok(%.ff.tok,2-,32) }
  set %.ff.found 0 | unset %.ff.did
  if (a !isin %.ff.opt) window -c @Express
  elseif ($_isopen(@Express)) {
    dline @Express 4
    dline @Express 3
    dline @Express 2
    dline @Express 1
    set %.ff.found $line(@Express,0)
  }
  window -nl $+ $_spec1d $_tabscale(7) @Express $_winpos(50,30,50,50) @Express %font.basic
  if (f isin %.ff.opt) {
    if ($exists($remove(%.ff.to,"))) aline -a @Express $remove(%.ff.to,")
    goto nextset
  }
  unset %.ff.group
  if (%.ff.to == $null) goto nextset
  :setloop
  if (: isin %.ff.to) {
    set %.ff.dr $asc(%.ff.to)
    set %.ff.last %.ff.dr
    set %.ff.to $gettok(%.ff.to,2-,58)
    if (%.ff.to == $null) set %.ff.to *.*
  }
  else {
    set %.ff.to %.ff.to
    set %.ff.dr 99
    set %.ff.last 122
    _progress.1 Finding files... Please wait...
    _progress.2 0 0% complete... (drive C:)
  }
  unset %.ff.dir
  if (\ isin %.ff.to) {
    if ($_numtok(92,%.ff.to) > 1) set %.ff.dir \ $+ $_ltok($_j($_numtok(92,%.ff.to)),92,%.ff.to)
    if ($right(%.ff.to,1) == \) set %.+ff.keep $true
    else unset %.+ff.keep
    set %.ff.to $_rtok(1,92,%.ff.to)
    if ((. !isin %.ff.to) || (%.+ff.keep)) {
      set %.ff.dir %.ff.dir $+ \ $+ %.ff.to
      set %.ff.to *.*
      set %.ff.dir $replace(%.ff.dir,\\,\)
    }
  }
  if (e !isin %.ff.opt) {
    set %.ff.to * $+ $_ffprep($replace(%.ff.to,$chr(32),*)) $+ *
    if (. isin $right(%.ff.to,6)) set %.ff.to $_lchop(1,%.ff.to)
    set %.ff.to $replace(%.ff.to,**,*)
  }
  :loop
  set %.ff.wh $chr(%.ff.dr) $+ : $+ %.ff.dir
  inc %.ff.found $findfile(%.ff.wh,%.ff.to,@Express)
  if ($_vi(.ff.dr) <= %.ff.last) {
    set %.ff.perc $int($calc((%.ff.dr - 99) * 100 / 24))
    _progress.2 %.ff.perc %.ff.perc $+ % complete... (drive $upper($chr(%.ff.dr)) $+ :)
    goto loop
  }
  if (%.ff.last < 122) set %.ff.did %.ff.did %.ff.wh $+ \ $+ %.ff.to
  else set %.ff.did %.ff.did *: $+ %.ff.dir $+ \ $+ %.ff.to
  window -c @Progress
  if ((%.ff.found < 1) && (%.ff.ok2 == $null)) {
    window -c @Express
    if (: isin $1) _error No files found matching  $+ %.ff.to $+  on drive $upper($chr(%.ff.last)) $+ :
    else _error No files found matching  $+ %.ff.to $+ 
  }
  :nextset
  set %.ff.ok2 ^_^
  if (c isin %.ff.opt) { set %.ff.to $mircdir | set %.ff.opt $remove(%.ff.opt,c) | goto setloop }
  if (p isin %.ff.opt) { set %.ff.to $mircdir $+ $_ppsub | set %.ff.opt $remove(%.ff.opt,p) | goto setloop }
  if (d isin %.ff.opt) { set %.ff.to $getdir | set %.ff.opt $remove(%.ff.opt,d) | goto setloop }
  if (L isin %.ff.opt) { set %.ff.to $logdir | set %.ff.opt $remove(%.ff.opt,L) | goto setloop }
  if (m isin %.ff.opt) {
    if (%.ff.group == $null) set %.ff.group $_mpdir
    set %.ff.to $gettok(%.ff.group,1,59)
    if ($right(%.ff.to,1) != \) set %.ff.to %.ff.to $+ \
    set %.ff.to %.ff.to $+ *.mp?
    set %.ff.group $gettok(%.ff.group,2-,59)
    if (%.ff.group == $null) set %.ff.opt $remove(%.ff.opt,m)
    goto setloop
  }
  if (w isin %.ff.opt) {
    if (%.ff.group == $null) set %.ff.group $_wavedir
    set %.ff.to $gettok(%.ff.group,1,59)
    if ($right(%.ff.to,1) != \) set %.ff.to %.ff.to $+ \
    set %.ff.to %.ff.to $+ *.wav
    set %.ff.group $gettok(%.ff.group,2-,59)
    if (%.ff.group == $null) set %.ff.opt $remove(%.ff.opt,w)
    goto setloop
  }
  if (i isin %.ff.opt) {
    if (%.ff.group == $null) set %.ff.group $_mididir
    set %.ff.to $gettok(%.ff.group,1,59)
    if ($right(%.ff.to,1) != \) set %.ff.to %.ff.to $+ \
    set %.ff.to %.ff.to $+ *.mid
    set %.ff.group $gettok(%.ff.group,2-,59)
    if (%.ff.group == $null) set %.ff.opt $remove(%.ff.opt,i)
    goto setloop
  }
  if (z isin %.ff.opt) {
    if (%.ff.sext == $null) set %.ff.sext $_mapext(%.ff.stype)
    if ((%.ff.group2 == $null) && (%.ff.group == $null)) set %.ff.group2 $_ppcfg(Sound, [ [ %.ff.sext ] $+ ] Dir)
    if (%.ff.group == $null) {
      set %.ff.to $gettok(%.ff.group2,1,59)
      if ($right(%.ff.to,1) != \) set %.ff.to %.ff.to $+ \
      set %.ff.to %.ff.to $+ *.
      set %.ff.group $_maprev(%.ff.sext,%.ff.to)
      set %.ff.group2 $gettok(%.ff.group2,2-,59)
    }
    set %.ff.to $gettok(%.ff.group,1,59)
    set %.ff.group $gettok(%.ff.group,2-,59)
    if ((%.ff.group2 == $null) && (%.ff.group == $null)) set %.ff.opt $remove(%.ff.opt,z)
    goto setloop
  }
  if (r isin %.ff.opt) set %.ff.did %.ff.did Recent files
  set %.ff.type Files
  :loopback
  if (r isin %.ff.opt) {
    set %.ff.files $_ppcfg(%.ff.type,Num)
    set %.ff.first %.ff.files
    :loopr1
    set %.ff.file $_ppcfg(%.ff.type,%.ff.files)
    if ($exists(%.ff.file)) { inc %.ff.found | aline @Express %.ff.file }
    if ($_vd(.ff.files) > 0) goto loopr1
    if (%.ff.first < 20) {
      set %.ff.files 20
      :loopr2
      set %.ff.file $_ppcfg(%.ff.type,%.ff.files)
      if (%.ff.file == $null) goto doner
      if ($exists(%.ff.file)) { inc %.ff.found | aline @Express %.ff.file }
      if ($_vd(.ff.files) > %.ff.first) goto loopr2
    }
    :doner
  }
  if (s isin %.ff.opt) { set %.ff.did %.ff.did DCC sends | set %.ff.opt $remove(%.ff.opt,s) $+ r | set %.ff.type Sends | goto loopback }
  if (g isin %.ff.opt) { set %.ff.did %.ff.did DCC gets | set %.ff.opt $remove(%.ff.opt,g) $+ r | set %.ff.type Gets | goto loopback }
  if (x isin %.ff.opt) {
    set %.ff.dat $_ppdir $+ dccinc.dat
    set %.ff.files $lines(%.ff.dat)
    if (%.ff.files > 0) {
      :loopx
      set %.ff.file $read -nl [ $+ [ %.ff.files ] ] %.ff.dat
      if (:g: isin $gettok(%.ff.file,1,32)) {
        inc %.ff.found
        aline @Express $gettok(%.ff.file,3-,32)
        set %_ffreqc. [ $+ [ $line(@Express,0) ] ] $gettok($gettok(%.ff.file,1,32),3-,58)
      }
      if ($_vd(.ff.files) > 0) goto loopx
      set %_findrcpop Request completion
    }
    set %.ff.did %.ff.did Incomplete DCC Gets
  }
  titlebar @Express File Finder ( $+ %.ff.found files found)
  sline @Express 1
  iline @Express 1 - Search performed :  $+ %.ff.did $+  -
  iline @Express 2 - Select file(s) and right-click for options -
  iline @Express 3 - Double-click will :  $+ %eff.click file $+  -
  iline @Express 4 $chr(160)
  if (n isin %.ff.opt) window -b @Express
  else window -arb @Express
}
ff find $1-
findzip {
  window -c @WinZip
  window -nl @WinZip /_finishzip %font.basic
  _progress.1 Searching for WinZip... Please wait...
  _progress.2 0 0% complete... (drive C:)
  set %.fz.dr 99 | unset %.fz.found
  :loop
  set %.fz.wh $chr(%.fz.dr) $+ :\
  inc %.fz.found $findfile(%.fz.wh,winzip*.exe,@WinZip)
  if ($_vi(.fz.dr) <= 122) {
    set %.fz.perc $int($calc((%.fz.dr - 99) * 100 / 24))
    _progress.2 %.fz.perc %.fz.perc $+ % complete... (drive $upper($chr(%.fz.dr)) $+ :)
    goto loop
  }
  window -c @Progress
  iline @WinZip 1 - Please double-click on the filename that corresponds to your copy of WinZip. -
  iline @WinZip 2 - If you do not have WinZip or do not wish to use it, double-click here -
  iline @WinZip 3 $chr(160)
  set %.wz.hi $int($calc($_rtok(1,32,%font.basic) * 1.6 * (3 + %.fz.found)))
  window -ar @WinZip $_center($calc( [ $window(-3).w ] - 100),%.wz.hi) $calc( [ $window(-3).w ] - 100) %.wz.hi
}
_finishzip {
  set %.line $sline(@WinZip,1).ln
  if ((%.line == 1) || (%.line == 3)) halt
  if (%.line == 2) { _writecfg Misc WinZip | disps No WinZip selected. }
  else { _writecfg Misc WinZip $sline(@WinZip,1) | disps WinZip selected- %col.info2 $+ $sline(@WinZip,1) }
  window -c @WinZip
}
; -----------------------------------------------------
; Color aliases
; -----------------------------------------------------
colorwin {
  window -c @Colors
  window -c @Colors
  window -lar $+ $_spec1d @Colors $_center(718,351) 718 351 @Colors1 Arial 716
  loadbuf @Colors $_ppdir $+ colors.txt
  sline @Colors 1
  sline -r @Colors 1
}
; note that the window is @Colors + $chr(160)
_cwinsel {
  set %.bk $sline(@Colors,1).ln
  if (%.bk < 1) halt
  set %.bk $_lpad(2,0,$_j(%.bk))
  window -c @Colors
  window -ln $+ $_spec1d @Colors $_center(150,352) 150 352 @Colors2 Arial 716
  set %.fg 0
  :loop
  aline @Colors  $+ %.fg $+ , $+ %.bk  --->   $_lpad(2,0,%.fg) on %.bk   <---       
  if ($_vi(.fg) < 16) goto loop
  window -lar @Colors
  window -c @Colors
}
_cwinsel2 {
  set %.line $sline(@Colors,1)
  window -c @Colors
  set %.col $gettok(%.line,1,32)
  editbox -a $editbox($active) $+ %.col
}
showcolor dispa 1,0 0 0,1 1 0,2 2 0,3 3 0,4 4 0,5 5 0,6 6 0,7 7 1,8 8 1,9 9 0,10 10 1,11 11 0,12 12 0,13 13 0,14 14 1,15 15 
saycolor say 1,0 0 0,1 1 0,2 2 0,3 3 0,4 4 0,5 5 0,6 6 0,7 7 1,8 8 1,9 9 0,10 10 1,11 11 0,12 12 0,13 13 0,14 14 1,15 15 
cncoff {
  if (%+cnc.on) { disp Click 'N' Color style disabled. | set %+cnc.on $false }
  set %cnc.fg 1 | set %cnc.bk 1 | set %cnc.attr 1 | set %cnc.patt 1 | set %cnc.text 1 | set %cnc.backw 1
  if ($_isopen(@FG)) { sline @FG 1 | sline @BK 1 | sline @Attr 1 | sline @Pattern 1 | sline @Text 1 | sline @Backwards 1 }
}
cnc {
  if ($1 == +) set %+cnc.on $true
  else set %+cnc.on $false
  if ($_isopen(@FG)) goto perform
  window -c @Click | window -r @Click 5 $calc( [ $window(-3).h ] - 435) 661 113 @CNC %font.quick
  titlebar @Click 'N' Color
  aline %col.cust @Click Select one option per column to design your text style. %col.custdark $+ Patterns override colors.
  aline %col.cust @Click Then press %col.custdark $+ F6 again to %col.custdark $+ style the text in the editbox of the current window.
  aline %col.cust @Click Press %col.custdark $+ ShiftF6 instead to use this style for %col.custdark $+ ALL future text until disabled.
  aline %col.cust @Click Press %col.custdark $+ CtrlF6 to %col.custdark $+ reset these settings to normal and %col.custdark $+ disable any %col.custdark $+ ShiftF6.
  set %.qc.text Black.Dark Blue.Dark Green.Bright Red.Dark Red.Dark Purple.Orange.Yellow.Bright Green.Dark Cyan.Bright Cyan.Light Blue.Light Purple.Dark Grey.Light Grey.White
  set %.qc.opp 0 0 0 0 0 0 0 1 1 0 1 0 0 0 1 1
  set %.qc.num 1
  set %.qc.fg $colour(norm)
  if (%.qc.fg == 0) set %.qc.fg 16
  set %.qc.bk $colour(back)
  if (%.qc.bk == 0) set %.qc.bk 16
  window -c @FG | window -lr @FG 5 $calc( [ $window(-3).h ] - 322) 140 296 @CNC Arial 11
  window -c @BK | window -lr @BK 145 $calc( [ $window(-3).h ] - 322) 140 296 @CNC Arial 11
  aline @FG  $+ $gettok(%.qc.opp,%.qc.fg,32) $+ , $+ %.qc.fg $+ $str($chr(160),11) $+ (normal fg) $+ $str($chr(160),25)
  aline @BK  $+ $gettok(%.qc.opp,%.qc.bk,32) $+ , $+ %.qc.bk $+ $str($chr(160),11) $+ (normal bk) $+ $str($chr(160),25)
  :loop
  aline %.qc.num @FG  $+ $gettok(%.qc.opp,%.qc.num,32) $+ , $+ %.qc.num $+ $str($chr(160),11) $+  $+ $gettok(%.qc.text,%.qc.num,46)) $+ $str($chr(160),25)
  aline %.qc.num @BK  $+ $gettok(%.qc.opp,%.qc.num,32) $+ , $+ %.qc.num $+ $str($chr(160),11) $+  $+ $gettok(%.qc.text,%.qc.num,46)) $+ $str($chr(160),25)
  if ($_vi(.qc.num) <= 16) goto loop
  aline @FG - One 4random color - | aline @FG - Many 03r06a02n06d10o13m colors -
  aline @BK - One 4random color - | aline @BK - Many 10r12a04n02d12o03m colors -
  window -c @Text | window -lr @Text 285 $calc( [ $window(-3).h ] - 160) 150 134 @CNC Arial 11
  aline @Text (normal letters)
  aline @Text UppErcAsE vOwEls
  aline @Text LoWeRCaSe VoWeLS
  aline @Text Am I, v !
  aline @Text RanDOM cAPitaLs
  aline @Text aLtErNaTiNg cApItAlS
  aline @Text First Letter Caps
  window -c @Backwards | window -lr @Backwards 435 $calc( [ $window(-3).h ] - 132) 231 106 @CNC Arial 15
  aline @Backwards (forward text)
  aline @Backwards txet sdrawkcaB
  aline @Backwards order word Reverse
  aline @Backwards sdrawkcaB sdrow
  window -c @Pattern | window -lr @Pattern 435 $calc( [ $window(-3).h ] - 322) 231 190 @CNC Arial 11
  aline @Pattern (no pattern, use selected colors)
  aline @Pattern 9,1C1,9h9,1e1,9c9,1k1,9e9,1r1,9e9,1d (uses selected colors)
  aline @Pattern 5,0H6u2e10v3o7l5u6t2i10o3n (can change bk color)
  aline @Pattern 0,1M15,14u14,15r1,0k14,15 15,14d0,1w15,14e14,15l1,0l14,15e15,14r
  aline @Pattern 8,1I7,1n4,1f5,1l4,1a7,1m8,1m7,1a4,1t5,1i4,1o7,1n (can change bk color)
  aline @Pattern 8,5R8,6a8,2i8,10n8,3b8,7o8,5w8,6 8,2r8,10o8,3a8,7d (can change fg color)
  aline @Pattern 2,0N10a3t9u15r9a3l10i2t10y (can change bk color)
  aline @Pattern 8,0/1P7/1s4/1y5/1c4/1h7/1o8/1c7/1y4/1c5/1l4/1e (uses selected colors)
  aline @Pattern 0,2-M0,12-a0,10-r0,11-q0,10-u0,12-e0,2-e0,12- 0,10-20,11-00,10-00,12-1 (can change colors)
  aline @Pattern 0,0|1A15|1l14|1l| 14|1v15|1e0|1n15|1t14|1 |u14|1p (can change colors)
  aline @Pattern 1,0Ru1nn14in1g 14ou14t 15of14 i15n15k (can change bk color)
  window -c @Attr | window -alr @Attr 285 $calc( [ $window(-3).h ] - 322) 150 162 @CNC Arial 11
  aline @Attr (no attributes)
  aline @Attr Bold
  aline @Attr Underline
  aline @Attr Both
  aline @Attr Random bold
  aline @Attr Random underline
  aline @Attr Random both
  aline @Attr Psychoid android
  aline @Attr Binary twitch
  sline @FG %cnc.fg | sline @BK %cnc.bk | sline @Pattern %cnc.patt | sline @Attr %cnc.attr | sline @Text %cnc.text | sline @Backwards %cnc.backw
  window -a @FG
  return
  :perform
  set %cnc.fg $sline(@FG,1).ln | if (%cnc.fg < 1) set %cnc.fg 1 | if ($2 != @FG) window -c @FG
  set %cnc.bk $sline(@BK,1).ln | if (%cnc.bk < 1) set %cnc.bk 1 | if ($2 != @BK) window -c @BK
  set %cnc.attr $sline(@Attr,1).ln | if (%cnc.attr < 1) set %cnc.attr 1 | if ($2 != @Attr) window -c @Attr
  set %cnc.patt $sline(@Pattern,1).ln | if (%cnc.patt < 1) set %cnc.patt 1 | if ($2 != @Pattern) window -c @Pattern
  set %cnc.text $sline(@Text,1).ln | if (%cnc.text < 1) set %cnc.text 1 | if ($2 != @Text) window -c @Text
  set %cnc.backw $sline(@Backwards,1).ln | if (%cnc.backw < 1) set %cnc.backw 1 | if ($2 != @Backwards) window -c @Backwards
  if ($2 != @Click) window -c @Click
  if ($1 == -) return
  if ((%cnc.fg == 1) && (%cnc.bk == 1) && (%cnc.attr == 1) && (%cnc.patt == 1) && (%cnc.text == 1) && (%cnc.backw == 1)) { set %+cnc.on $false | return }
  if ($1 == +) { disp Click 'N' Color style enabled- $_cncapply(This is an example) | return }
  set %.cnc.edit $editbox($active)
  if (%.cnc.edit == $null) { _askr _cncedit Text to apply style to? }
  _cncedit %.cnc.edit
}
color set %.did $_colapplycmd(colori,$1-) | if ($left(%.did,1) != /) say %.did | else %.did
color2 set %.did $_colapplycmd(color2i,$1-) | if ($left(%.did,1) != /) say %.did | else %.did
funky set %.did $_colapplycmd(funkyi,$1-) | if ($left(%.did,1) != /) say %.did | else %.did
checker set %.did $_colapplycmd(checker2i,$1-) | if ($left(%.did,1) != /) say %.did | else %.did
codes set %.did $_colapplycmd(codei,$1-) | if ($left(%.did,1) != /) say %.did | else %.did
_cncapplycmd return $_colapplycmd(_cncapply,$1-)
_colapplycmd {
  if ($left($2,1) == /) {
    if ($findtok(disp.say.me.ame.amsg.aame.aamsg.acme.acmsg.away.back.a.b.quit,$remove($remove($2,.),/),46) != $null) return $2 $ [ $+ [ $1 $+ [ ( $+ $3- $+ ) ] ] ]
    elseif ($findtok(msg.describe.n.notice.q.query.allbut.ctcp.ctcpreply,$remove($remove($2,.),/),46) != $null) return $2-3 $ [ $+ [ $1 $+ [ ( $+ $4- $+ ) ] ] ]
    elseif ($findtok(o.wall.massn.onotice.ovnotice.wallvoc.vonotice.ov.vo.t.topic.part.p,$remove($remove($2,.),/),46) != $null) {
      if ($_ischan($3)) return $2-3 $ [ $+ [ $1 $+ [ ( $+ $4- $+ ) ] ] ]
      else return $2 $ [ $+ [ $1 $+ [ ( $+ $3- $+ ) ] ] ]
    }
    else return $2-
  }
  else return $ [ $+ [ $1 $+ [ ( $+ $2- $+ ) ] ] ]
}
_cncedit editbox -a $_cncapplycmd($1-)
_cncapply {
  if ($1 == $null) return
  set %.cnc.do $1-
  if (%cnc.backw == 2) set %.cnc.do $backwardsi(%.cnc.do)
  elseif (%cnc.backw == 3) set %.cnc.do $backwordsi(%.cnc.do)
  elseif (%cnc.backw == 4) set %.cnc.do $backwardsi($backwordsi(%.cnc.do))
  if (%cnc.text == 2) set %.cnc.do $uvoweli(%.cnc.do)
  elseif (%cnc.text == 3) set %.cnc.do $lvoweli(%.cnc.do)
  elseif (%cnc.text == 4) set %.cnc.do $asciii(%.cnc.do)
  elseif (%cnc.text == 5) set %.cnc.do $randcapi(%.cnc.do)
  elseif (%cnc.text == 6) set %.cnc.do $altcapi(%.cnc.do)
  elseif (%cnc.text == 7) set %.cnc.do $initcapi(%.cnc.do)
  set %.cnc.bk $_j(%cnc.bk)
  if (%.cnc.bk < 1) {
    if ((%cnc.patt < 3) || (%cnc.patt == 8)) set %.cnc.bk $colour(back)
    else set %.cnc.bk $gettok(0-0-0-0-1-0-0-0-1-0-0,%cnc.patt,45)
  }
  if (%.cnc.bk < 1) set %.cnc.bk 16
  set %.cnc.fg $_j(%cnc.fg)
  if (%.cnc.fg < 1) {
    if ((%cnc.patt < 3) || (%cnc.patt == 8)) set %.cnc.fg $colour(norm)
    else set %.cnc.fg $gettok(0-0-0-0-0-8-0-1-0-1-0,%cnc.patt,45)
  }
  if (%.cnc.fg < 1) set %.cnc.fg 16
  set %.cnc.match 16-4-7-8-9-10-11-13-14-15,16-3-4-7-8-9-10-11-13-15,16-1-2-5-6-8-9-11-12-15,16-1-2-5-6-8-9-11-12-15,16-3-4-7-8-9-10-11-13-15,16-1-2-4-7-8-9-11-13-15,16-1-2-5-6-8-9-11-12-15,1-2-3-4-5-6-10-12-13-14,1-2-3-4-5-6-10-12-13-14,16-1-2-5-6-8-9-11-12-15,1-2-3-4-5-6-10-12-13-14,16-1-2-5-7-8-9-11-13-15,16-1-2-5-6-8-9-11-12-15,16-1-2-5-6-8-9-11-12-15,1-2-3-4-5-6-10-12-13-14,1-2-3-4-5-6-10-12-13-14
  if (%.cnc.bk == 17) {
    if (%.cnc.fg > 16) set %.cnc.bk $r(1,16)
    else set %.cnc.bk $gettok($gettok(%.cnc.match,%.cnc.fg,44),$r(1,10),45)
  }
  if (%.cnc.bk == 18) set %.cnc.bk 17
  if (%.cnc.fg == 17) {
    if (%.cnc.bk > 16) set %.cnc.fg $r(1,16)
    else set %.cnc.fg $gettok($gettok(%.cnc.match,%.cnc.bk,44),$r(1,10),45)
  }
  if (%.cnc.fg == 18) set %.cnc.fg 17
  unset %.cnc.l*
  if (((%cnc.patt == 1) && (%.cnc.bk != 17)) || (%cnc.patt == 11)) {
    if (%cnc.attr == 5) set %.cnc.do $boldi(%.cnc.do)
    elseif (%cnc.attr == 6) set %.cnc.do $ulinei(%.cnc.do)
    elseif (%cnc.attr == 7) set %.cnc.do $codei(%.cnc.do)
    elseif (%cnc.attr == 8) set %.cnc.do $pati(6,%.cnc.do)
    elseif (%cnc.attr == 9) set %.cnc.do $pati(8,%.cnc.do)
    if (%cnc.patt == 11) {
      if (%.cnc.bk > 16) set %.cnc.bk 16
      set %.cnc.do 1, $+ %.cnc.bk $+ $fadei(1.1.14.1.14.14.15.14.15.15,%.cnc.do)
    }
    elseif ((%cnc.fg != 1) || (%cnc.bk != 1)) {
      if (%.cnc.fg == 17) set %.cnc.do 0, $+ %.cnc.bk $+ $colori(%.cnc.do)
      else set %.cnc.do  $+ %.cnc.fg $+ , $+ $calc(16 + %.cnc.bk) $+ %.cnc.do
    }
  }
  elseif ((%cnc.patt == 2) && (%cnc.attr < 5)) {
    if ((%.cnc.fg == 17) && (%.cnc.bk == 17)) set %.cnc.do $checkeri(%.cnc.do)
    else {
      if (%.cnc.fg == 17) { set %.cnc.fg %.cnc.bk | set %.cnc.bk 17 }
      if (%.cnc.bk == 17) set %.cnc.chk  $+ %.cnc.fg $+ , $+ $_lpad(2,0,$gettok($gettok(%.cnc.match,%.cnc.fg,44),$r(1,10),45)) $+ . $+ $gettok($gettok(%.cnc.match,%.cnc.fg,44),$r(1,10),45) $+ , $+ $_lpad(2,0,%.cnc.fg)
      else set %.cnc.chk  $+ %.cnc.fg $+ , $+ $_lpad(2,0,%.cnc.bk) $+ . $+ %.cnc.bk $+ , $+ $_lpad(2,0,%.cnc.fg)
      _pattern %.cnc.chk %.cnc.do
      set %.cnc.do $result
    }
  }
  else {
    if (%cnc.attr == 5) set %.cnc.la r.b.$
    elseif (%cnc.attr == 6) set %.cnc.la r.u.$
    elseif (%cnc.attr == 7) set %.cnc.la r.b.u.ub.$
    elseif (%cnc.attr == 8) set %.cnc.la c.u.b.b.u
    elseif (%cnc.attr == 9) { set %.cnc.la2 c.u.us.u.u | set %.cnc.lp o.0 | set %.cnc.lp2 o.+0 }
    if (%cnc.patt == 1) { set %.cnc.lp o.0 | set %.cnc.lp2 o.+0 }
    elseif (%cnc.patt == 2) { if (%cnc.attr == 9) set %.cnc.la c.us.us.us.u | else set %.cnc.lp o.s }
    elseif (%cnc.patt == 3) set %.cnc.lp c.5.6.2.10.3.7
    elseif (%cnc.patt == 4) { set %.cnc.lp p.16.15.14.1 | set %.cnc.lp2 p.+1.+14.+15.+16 }
    elseif (%cnc.patt == 5) set %.cnc.lp p.8.7.4.5
    elseif (%cnc.patt == 6) { if (%cnc.attr == 9) set %.cnc.lp2 o.0 | set %.cnc.lp c.+5.+6.+2.+10.+3.+7 }
    elseif (%cnc.patt == 7) set %.cnc.lp p.2.10.3.9.15
    elseif (%cnc.patt == 8) { set %.cnc.lp o.0 | set %.cnc.lia p.8.7.4.5 | set %.cnc.lic o./ }
    elseif (%cnc.patt == 9) { if (%cnc.attr == 9) set %.cnc.lp2 o.0 | set %.cnc.lp o.+0 | set %.cnc.lia p.+2.+12.+10.+11 | set %.cnc.lic o.- }
    elseif (%cnc.patt == 10) { set %.cnc.lp o.0b | set %.cnc.lia p.16b.15b.14b.1b | set %.cnc.lic 0.| }
    if (%.cnc.lia == $null) set %.cnc.ni 0 | else set %.cnc.ni 1 1
    set %.cnc.na 0 | if (%.cnc.la != $null) inc %.cnc.na | if (%.cnc.la2 != $null) inc %.cnc.na
    if (%.cnc.lp != $null) inc %.cnc.na | if (%.cnc.lp2 != $null) inc %.cnc.na
    set %.cnc.do %.cnc.fg %.cnc.bk $ %.cnc.ni %.cnc.lia %.cnc.lic %.cnc.na %.cnc.lpa %.cnc.la %.cnc.lp %.cnc.lp2 %.cnc.la2 $_s2p(%.cnc.do)
    set %.cnc.do $_spg(%.cnc.do)
  }
  if ((%cnc.patt == 2) || (%cnc.patt == 5) || (%cnc.patt == 10)) set %.cnc.do  $+ %.cnc.do
  if (%cnc.attr == 2) set %.cnc.do  $+ %.cnc.do
  elseif (%cnc.attr == 3) set %.cnc.do  $+ %.cnc.do
  elseif (%cnc.attr == 4) set %.cnc.do  $+ %.cnc.do
  return %.cnc.do
}
; Super pattern generator
; FG BK IA NI [NA AL ... CL] ... NA [AL ...] TX
; FG = foreground (1-16, >16=pick randomly each use)
; BK = background (same)
; IA = initial attributes (b/u/r)
; NI = number of interweaves
; Each interweave-
;   NA = number of attribute layers
;   Each layer-
;     AL = Attribute layer in 1.2.3.4.etc format (one code per token)
;   CL = Character layer in 1.2.3.4.etc format
; NA = number of attribute layers
; Each layer-
;   AL = Attribute layer in 1.2.3.4.etc format (one code per token)
; TX = Text to pattern, with  for spaces
; Attribute layer codes-         +## = set background to, ## = set foreground to, b = toggle bold, u = toggle underline, [+]##[bu] do both
; (## =1 or 2 digit, 0 = default)  s = swap fg/bk, $ = null
; first token of attr layer - c = cycle through in order, p = ping pong start to end to start, r = pick randomly, s = stutter (advance 1 or 2 randomly) z = stutter ping pong o = cycle once then stay on last
; Character layer- first token ala attr layer, rest is just char(s) to interweave, use $ for null,  for space
; Theoretically, each interweave layer is created using it's chars and attributes, then the main is created with one bit of each interweave
; layer (in order) before each character. NO ERROR CHECKING PERFORMED.
; example for simple random-color checkerboard-
; _spg 17 17 b 0 1 o.s Sampletext
; example for text that cycles ltgrey to black and back, randomly reversing, weaved with lines that cycle thru red colors, all w/a random cyan/white bk with underline 2 on 2 off
; _spg 1 0 $ 1 3 c.$.u.$.u r.+16.+11 p.05.04.07.08 o.| 2 p.015.014.01 r.$.s Sampletext
_spg {
  unset %..*
  set %..c.fg $1 | set %..c.bk $2
  if (u isin $3) set %..ret  | if (b isin $3) set %..ret %..ret 
  set %..s.fg -1 | set %..s.bk -1
  set %..match 16-4-7-8-9-10-11-13-14-15,16-3-4-7-8-9-10-11-13-15,16-1-2-5-6-8-9-11-12-15,16-1-2-5-6-8-9-11-12-15,16-3-4-7-8-9-10-11-13-15,16-1-2-4-7-8-9-11-13-15,16-1-2-5-6-8-9-11-12-15,1-2-3-4-5-6-10-12-13-14,1-2-3-4-5-6-10-12-13-14,16-1-2-5-6-8-9-11-12-15,1-2-3-4-5-6-10-12-13-14,16-1-2-5-7-8-9-11-13-15,16-1-2-5-6-8-9-11-12-15,16-1-2-5-6-8-9-11-12-15,1-2-3-4-5-6-10-12-13-14,1-2-3-4-5-6-10-12-13-14
  set %..pos 0
  :rest
  set %..outer $_i($4)
  set %..parm 5
  :outer
  set %..inner $gettok($1-,%..parm,32)
  inc %..parm
  if (%..inner > 0) {
    :inner
    set %..layer $gettok($1-,%..parm,32)
    _spg_bs %..parm
    set %..tok $gettok(%..layer,%..tok,46)
    if (u isin %..tok) set %..ret %..ret $+ 
    if (b isin %..tok) set %..ret %..ret $+ 
    if (s isin %..tok) { set %..c.tmp %..c.fg | set %..c.fg %..c.bk | set %..c.bk %..c.tmp }
    set %..tok $remove($remove($remove(%..tok,u),b),s)
    if (+ isin %..tok) {
      set %..c.bk %..tok
      if (%..c.bk == 0) set %..c.bk $2
    }
    elseif (%..tok isnum) { set %..c.fg %..tok | if (%..c.fg == 0) set %..c.fg $1 }
    if ($_vd(..inner) > 0) goto inner
  }
  set %..layer $gettok($1-,%..parm,32)
  if (%..outer == 1) { inc %..pos | set %..bit $mid(%..layer,%..pos,1) | if (%..bit == $null) return $_p2s(%..ret) | goto dobit }
  else { _spg_bs %..parm | set %..bit $gettok(%..layer,%..tok,46) }
  if (%..bit != $) {
    :dobit
    if (%..c.bk == 17) { if (%..c.fg > 16) set %..c.bk $r(1,16) | else set %..c.bk $gettok($gettok(%..match,%..c.fg,44),$r(1,10),45) }
    if (%..c.fg == 17) set %..c.fg $gettok($gettok(%..match,%..c.bk,44),$r(1,10),45)
    if (%..s.bk != %..c.bk) { set %..ret %..ret $+  $+ $calc(%..c.fg) $+ , $+ $calc(16 + %..c.bk) | set %..s.bk %..c.bk | set %..s.fg %..c.fg }
    elseif (%..s.fg != %..c.fg) { set %..ret %..ret $+  $+ $calc(16 + %..c.fg) | set %..s.fg %..c.fg }
    set %..ret %..ret $+ %..bit
  }
  if ($_vd(..outer) > 0) goto outer | goto rest
}
_spg_bs {
  inc %..parm
  set %..bit $left(%..layer,1)
  if (%..bit == r) set %..tok $r(2,$_i($count(%..layer,.)))
  else {
    set %..num $count(%..layer,.)
    set %..tok %.. [ $+ [ $1 ] ]
    if (%..bit isin sz) inc %..tok $r(1,2)
    else inc %..tok
    if (%..tok > %..num) {
      if (%..bit == o) set %..tok %..num
      elseif (%..bit isin pz) dec %..tok $calc(%..num * 2 - 2)
      else dec %..tok %..num
    }
    set %.. [ $+ [ $1 ] ] %..tok
    if (%..tok <= 0) set %..tok $calc(3 - %..tok)
    else inc %..tok
  }
}
; -----------------------------------------------------
; Display hostmask
; -----------------------------------------------------
host {
  if ($1 == $null) _quickhelp /host
  if (. isin $1) set %.nk $1 | else set %.nk $_nickglob($1)
  if (($address(%.nk,5) == $null) && ($_not($_ismask(%.nk)))) _lookup %.nk ! host , %.nk
  if ($2 != $null) dispa Hostmask for $2 is- %col.info1 $+ $_ppmask(%.nk,3)
  else dispa Hostmask for %.nk is- %col.info1 $+ $_ppmask(%.nk,3)
}
; -----------------------------------------------------
; Channel scan
; -----------------------------------------------------
; flags- rawihslmd
scan {
  if (($_ismask($1)) || ($_ismask($2))) { clones $1- | return }
  _psplit cs $1-
  if (%.cs.param == $null) set %.cs.param %chanscan.default
  set %-cscando $addtok(%-cscando,%.cs.chan,32)
  .enable #-chanscan
  set %-cscantype. [ $+ [ %.cs.chan ] ] %.cs.param
  .raw who %.cs.chan
}
